#include "categoryobjectbuilder.h"
#include "constants.h"

#include <objects/category.h>

namespace ao_builder
{
std::unique_ptr<Object> CategoryObjectBuilder::buildObject(ObjectParserInterface *parser)
{
    auto result = std::make_unique<Category>();

    QString buildingFromSection = ALTERATOR_ENTRY_SECTION_NAME;

    if (!buildBase(parser, buildingFromSection, result.get()))
    {
        return nullptr;
    }

    if (!buildFieldWithLocale(parser,
                              buildingFromSection,
                              ALTERATOR_ENTRY_OBJECT_KEY_DISPLAY_NAME,
                              result->m_displayName,
                              result->m_displayNameLocaleStorage))
    {
        return nullptr;
    }

    if (!buildFieldWithLocale(parser,
                              buildingFromSection,
                              CATEGORY_COMMENT_KEY_NAME,
                              result.get()->m_comment,
                              result.get()->m_commentLocaleStorage))
    {
        return nullptr;
    }

    QString icon = parser->getValue(buildingFromSection, CATEGORY_ICON_KEY_NAME);
    if (icon.isEmpty())
    {
        return nullptr;
    }
    result->m_icon = icon;

    return result;
}
} // namespace ao_builder
