#include "objectbuilder.h"
#include "constants.h"

#include <memory>

namespace ao_builder
{
std::unique_ptr<Object> ObjectBuilder::buildObject(ObjectParserInterface *parser)
{
    auto result = std::make_unique<Object>();

    if (!buildBase(parser, ALTERATOR_ENTRY_SECTION_NAME, result.get()))
    {
        return nullptr;
    }

    if (!buildFieldWithLocale(parser,
                              ALTERATOR_ENTRY_SECTION_NAME,
                              ALTERATOR_ENTRY_OBJECT_KEY_DISPLAY_NAME,
                              result->m_displayName,
                              result->m_displayNameLocaleStorage))
    {
        return nullptr;
    }

    QString categoryId   = parser->getValue(ALTERATOR_ENTRY_SECTION_NAME, OBJECT_CATEGORY_KEY_NAME);
    result->m_categoryId = categoryId;

    QString icon   = parser->getValue(ALTERATOR_ENTRY_SECTION_NAME, OBJECT_ICON_KEY_NAME);
    result->m_icon = icon;

    result->m_isLegacy = false;

    return result;
}
} // namespace ao_builder
